#include "bullet.hpp"

// Rect => x, y -> pos du tireur
//         width, height -> distance de la souris
Bullet::Bullet(RessourceManager* rm, int damage, sf::FloatRect rect) :
    Entity(rm, new Sprite(rm->getTexture("data\\graphics\\map\\common\\bullet.png")), SpriteFilled, false, true),
    m_vitesse(500.f)
{
    m_sprite->setPosition(rect.left, rect.top);
    refreshHitbox();

    m_damageAmount = damage;

    float total = fabs(rect.width) + fabs(rect.height);

    m_ratioX = rect.width / total;
    m_ratioY = rect.height / total;
}

Bullet::~Bullet() {}

void Bullet::update(float t)
{
    m_sprite->move(m_ratioX * m_vitesse * t, m_ratioY * m_vitesse * t);
}

sf::Vector2f Bullet::getPosition()
{
    return m_sprite->getPosition();
}
