#ifndef CONSOLEMINIGAME_HPP
#define CONSOLEMINIGAME_HPP

// C++
#include <vector>
#include <cmath>
// SFML
// Projet
#include "gamestate.hpp"
#include "sprite.hpp"

class ConsoleMinigame : public GameState
{
public:
    ConsoleMinigame(RessourceManager*);
    virtual ~ConsoleMinigame();
    virtual void draw();
    virtual void update(float t);
    virtual bool event(const sf::Event&);
    // Permet d'effacer les lignes/caractres en trop;
    virtual void refreshConsole();

    // Renvoie true si le joueur  termin le mini jeu
    virtual bool check(std::string&) = 0;

protected:
    // C++
    bool tiretAffiche, m_termine, m_peuxRentrerNb, m_peuxRentrerChar;
    float delaiTiret;
    int tailleLigneMax, nbLigneMax;
    std::vector<int> m_nombreEntres;
    std::vector<char> m_charEntres;
    // SFML
    sf::Text m_texteConsole;
    // Projet
    Sprite* m_background;
};

class PlusOuMoins : public ConsoleMinigame
{
public:
    PlusOuMoins(RessourceManager*, int);
    virtual ~PlusOuMoins();
    virtual bool check(std::string&);

private:
    // C++
    int m_nbCaractere;
    unsigned int m_code;
    // SFML
    // Projet
};

class MasterMind : public ConsoleMinigame
{
public:
    MasterMind(RessourceManager*, int, int);
    virtual ~MasterMind();
    virtual bool check(std::string&);

private:
    // C++
    int m_nbCaractere, m_idAActiver;
    std::vector<int> m_code;
    // SFML
    // Projet
};

#endif // CONSOLEMINIGAME_HPP
