#ifndef DIALOGUE_HPP
#define DIALOGUE_HPP

// C++
#include <vector>
#include <string>
#include <fstream>
// SFML
#include <SFML/Graphics/Sprite.hpp>
// Projet
#include "gamestate.hpp"
#include "sprite.hpp"
#include "collisions.hpp"

// TODO
/*
  Faire une methode pour charger le prochain dialogue
  Nettoyer le code (touche espace prsse + chargement)
  //m_RManager->getApplication().addGameState(new Dialogue(m_RManager, "data\\maps\\" + m_mapName + "\\dialogue\\test.dia"));
*/

class Actor
{
public:
    Actor(RessourceManager*, const std::string, const std::string, const sf::Color);
    ~Actor();
    void setPosition(int, int);
    void draw();
    const sf::Sprite& getBackground();

private:
    // C++
    std::string m_backgroundName;
    // SFML
    sf::Text m_nom;
    sf::Sprite m_avatar, m_background;
    // Projet
    RessourceManager* m_RManager;
};

class Dialogue : public GameState
{
public:
    Dialogue(RessourceManager*, const std::string, int idAActiver = -1);
    ~Dialogue();
    void draw();
    bool event(const sf::Event&);
    void update(float);
    void chargerDialogue();

private:
    void load();

    // C++
    std::ifstream fichier;
    int m_acteurActif;
    int m_idEntiterAActiver;
    // SFML
    sf::Text m_dialogue;
    // Projet
    std::vector<Actor*> m_Actors;
    AnimatedSprite* m_waitForInput;
};

#endif // DIALOGUE_HPP
