#ifndef ENTITY_HPP
#define ENTITY_HPP

// C++
// SFML
// Projet
#include "ressourcemanager.hpp"
#include "sprite.hpp"

enum HitboxType{None, SpriteFilled};

class Entity
{
public:
    Entity(RessourceManager*, Sprite*, HitboxType, int x, int y,
           bool solid = true, bool deadly = false, bool shootable = false, bool activable = false, float delay = 0.f);
    virtual ~Entity();
    virtual void draw();
    virtual void update(float);
    virtual void activate();
    virtual void onShoot();
    virtual void onCollision();
    virtual bool isSolid();
    virtual bool isDeadly();
    virtual int getDamage();
    virtual bool isShootable();
    virtual bool isActivable();
    virtual sf::FloatRect getHitbox();
    virtual const Sprite& getSprite();
    virtual void setVisible(bool);

protected:
    virtual void refreshHitbox();

    // C++
    bool m_solid, m_deadly, m_shootable, m_activable, m_visible; // Solide, mortel (de damageAmount pts de dgats), tirable, activable par le joueur
    int m_damageAmount; // Degats infligs au joueur si collision
    bool m_active; // Activ ou non
    float m_tpsDepuisActivation;
    float m_delay; // Temps entre chaque activation -1 si activation unique
    // SFML
    sf::FloatRect m_hitbox;
    // Projet
    RessourceManager* m_RManager;
    Sprite* m_sprite;
    HitboxType m_typeHitbox;
};

#endif // ENTITY_HPP
