#ifndef MAP_HPP
#define MAP_HPP

// C++
#include <iostream>
#include <string>
#include <fstream>
#include <map>
#include <vector>
// SFML
#include <SFML/Graphics/Sprite.hpp>
// Projet
#include "gamestate.hpp"
#include "player.hpp"
#include "sprite.hpp"
#include "entity.hpp"
#include "bullet.hpp"

class Map : public GameState
{
public:
    Map(RessourceManager*, const std::string, const std::string, Player* player = 0);
    ~Map();
    void draw();
    bool event(const sf::Event&);
    void update(float);
    void changeMap(const std::string);
    Player* getPlayer();
    std::string getMapName();
    void activerEntite(int);
    void addBullet(Bullet*);
    void setEntityVisible(int, bool);

private:
    void load(const std::string);
    void save();
    Sprite* loadSprite(std::ifstream&);

    // C++
    std::string m_pathGraphics, m_mapName, m_pathSave;
    // SFML
    // Projet
    Sprite* m_background;
    Player* m_player;
    std::map<int, Entity*> m_Entity;
    std::vector<Bullet*> m_Bullet;
};

#endif // MAP_HPP

