#include "mapentity.hpp"
#include "application.hpp"
#include "player.hpp"
#include "screen.hpp"
#include "map.hpp"

CurrentLevelVortex::CurrentLevelVortex(RessourceManager* rm, int x, int y) : Entity(rm, 0, None, x, y, false)
{
    m_sprite = new RepeatedSprite(rm->getTexture("data\\graphics\\map\\common\\currentLevelVortex.png"), 0, 100);
    m_sprite->setPosition(x, y);
    Player* player = m_RManager->getMap()->getPlayer();
    m_RManager->getMap()->getPlayer()->setPosition(
                m_sprite->getPosition().x + m_sprite->getTextureRect().width / 2 - player->getHitbox().width / 2,
                m_sprite->getPosition().y + m_sprite->getTextureRect().height / 2 - player->getHitbox().height / 2);
}

CurrentLevelVortex::~CurrentLevelVortex() {}

NextLevelVortex::NextLevelVortex(RessourceManager* rm, std::string nextLvl, int x, int y) : Entity(rm, 0, SpriteFilled, x, y, true),
    m_nextLevelName(nextLvl)
{
    m_sprite = new RepeatedSprite(rm->getTexture("data\\graphics\\map\\common\\nextLevelVortex.png"), 0, -100);
    m_sprite->setPosition(x, y);
    refreshHitbox();
}

NextLevelVortex::~NextLevelVortex() {}

void NextLevelVortex::onCollision()
{
    Player* player = m_RManager->getMap()->getPlayer();
    m_RManager->getMap()->getPlayer()->setPosition(
                m_sprite->getPosition().x + m_sprite->getTextureRect().width / 2 - player->getHitbox().width / 2,
                m_sprite->getPosition().y + m_sprite->getTextureRect().height / 2 - player->getHitbox().height / 2);

    m_RManager->getApplication().addGameState(new MapInterlude(m_RManager, m_nextLevelName));
}
