#include "newgamemenu.hpp"
#include "application.hpp"
#include "map.hpp"
#include "collisions.hpp"

NewGameMenu::NewGameMenu(RessourceManager* rm) : GameState(rm, true, true)
{
    // On charge les images
    m_background.setTexture(m_RManager->getTexture("data\\graphics\\window\\newGameMenu\\background.png"));
    m_flecheBack.setTexture(m_RManager->getTexture("data\\graphics\\window\\flecheBack.png"));
    m_flecheBack.setPosition(5, 5);

    // On regarde quelle sauvegarde existe
    std::ifstream fichier("data\\saves\\01\\save.sv");

    if(fichier.fail())
    {
        std::cout << " -*- Loading Menu : Slot 1 non present" << std::endl;
        m_slot_existe[0] = false;
        m_slot_icon[0].setTexture(m_RManager->getTexture("data\\graphics\\window\\newGameMenu\\slot.png"));
        m_slot_icon[0].setPosition(347, 211);
    }
    else
    {
        std::cout << " -- Loading Menu : Slot 1 present" << std::endl;
        m_slot_existe[0] = true;

        std::string op;

        while(!fichier.eof())
        {
            fichier >> op;

            if(op == "[Map]")
            {
                std::string mapName;
                fichier >> mapName;
                m_slot_icon[0].setTexture(m_RManager->getTexture("data\\graphics\\map\\" + mapName + "\\mapIcon.png"));
                m_slot_icon[0].setPosition(348, 212);
            }
        }
    }

    fichier.close();
    fichier.open("data\\saves\\02\\save.sv");

    if(fichier.fail())
    {
        std::cout << " -*- Loading Menu : Slot 2 non present" << std::endl;
        m_slot_existe[1] = false;
        m_slot_icon[1].setTexture(m_RManager->getTexture("data\\graphics\\window\\newGameMenu\\slot.png"));
        m_slot_icon[1].setPosition(347, 302);
    }
    else
    {
        std::cout << " -- Loading Menu : Slot 2 present" << std::endl;
        m_slot_existe[1] = true;

        std::string op;

        while(!fichier.eof())
        {
            fichier >> op;

            if(op == "[Map]")
            {
                std::string mapName;
                fichier >> mapName;
                m_slot_icon[1].setTexture(m_RManager->getTexture("data\\graphics\\map\\" + mapName + "\\mapIcon.png"));
                m_slot_icon[1].setPosition(348, 303);
            }
        }
    }

    fichier.close();
    fichier.open("data\\saves\\03\\save.sv");

    if(fichier.fail())
    {
        std::cout << " -*- Loading Menu : Slot 3 non present" << std::endl;
        m_slot_existe[2] = false;
        m_slot_icon[2].setTexture(m_RManager->getTexture("data\\graphics\\window\\newGameMenu\\slot.png"));
        m_slot_icon[2].setPosition(347, 395);
    }
    else
    {
        std::cout << " -- Loading Menu : Slot 3 present" << std::endl;
        m_slot_existe[2] = true;

        std::string op;

        while(!fichier.eof())
        {
            fichier >> op;

            if(op == "[Map]")
            {
                std::string mapName;
                fichier >> mapName;
                m_slot_icon[2].setTexture(m_RManager->getTexture("data\\graphics\\map\\" + mapName + "\\mapIcon.png"));
                m_slot_icon[2].setPosition(348, 396);
            }
        }
    }

    fichier.close();
}

NewGameMenu::~NewGameMenu()
{
    for(unsigned int i(0); i < 3; i++)
        m_RManager->killTexture(m_slot_icon[i].getTexture());

    m_RManager->killTexture(m_background.getTexture());
    m_RManager->killTexture(m_flecheBack.getTexture());
}

void NewGameMenu::draw()
{
    m_RManager->getWindow().draw(m_background);

    for(unsigned int i(0); i < 3; i++)
        m_RManager->getWindow().draw(m_slot_icon[i]);

    m_RManager->getWindow().draw(m_flecheBack);
}

bool NewGameMenu::event(const sf::Event& e)
{
    if(e.type == sf::Event::MouseButtonReleased)
    {
        for(unsigned int i(0); i < 3; i++)
        {
            if(collisionSourisSprite(e.mouseButton.x, e.mouseButton.y, m_slot_icon[i]))
            {
                std::string slotStr;

                if(i == 0)
                    slotStr = "01";
                else if(i == 1)
                    slotStr = "02";
                else if(i == 2)
                    slotStr = "03";

                std::string path("data\\saves\\" + slotStr + "\\save.sv");

                m_RManager->getApplication().addGameState(new Map(m_RManager, "01_USB", path));
            }
        }

        if(collisionSourisSprite(e.mouseButton.x, e.mouseButton.y, m_flecheBack))
            m_RManager->getApplication().popGameState();
    }
    else if(e.type == sf::Event::KeyReleased)
    {
        if(e.key.code == sf::Keyboard::Escape)
        {
            m_RManager->getApplication().popGameState();
        }
    }

    return m_modal;
}
