#include "pausemenu.hpp"
#include "application.hpp"
#include "collisions.hpp"
#include "screen.hpp"

PauseMenu::PauseMenu(RessourceManager* rm) : GameState(rm, true, false)
{
    m_RManager->pauseBGM();

    m_background.setTexture(m_RManager->getTexture("data\\graphics\\window\\pausemenu\\background.png"));

    m_continuer.setTexture(m_RManager->getTexture("data\\graphics\\window\\pausemenu\\jeu.png"));
    m_continuer.setPosition(190, 320);

    m_retourMenuPrincipal.setTexture(m_RManager->getTexture("data\\graphics\\window\\pausemenu\\menu.png"));
    m_retourMenuPrincipal.setPosition(190, 410);

    m_commandes.setTexture(m_RManager->getTexture("data\\graphics\\window\\commandes\\bouton.png"));
    m_commandes.setPosition(10, 450);

    m_RManager->setMouseCursor("fleche");
}

void PauseMenu::draw()
{
    m_RManager->getWindow().draw(m_background);
    m_RManager->getWindow().draw(m_continuer);
    m_RManager->getWindow().draw(m_retourMenuPrincipal);
    m_RManager->getWindow().draw(m_commandes);
}

bool PauseMenu::event(const sf::Event& event)
{
    if(event.type == sf::Event::KeyReleased)
    {
        if(event.key.code == sf::Keyboard::Escape)
            m_RManager->getApplication().popGameState();
    }else if(event.type == sf::Event::MouseButtonReleased)
    {
        if(collisionSourisSprite(event.mouseButton.x, event.mouseButton.y, m_continuer))
            m_RManager->getApplication().popGameState();
        else if(collisionSourisSprite(event.mouseButton.x, event.mouseButton.y, m_retourMenuPrincipal))
            m_RManager->getApplication().mainMenu();
        else if(collisionSourisSprite(event.mouseButton.x, event.mouseButton.y, m_commandes))
            m_RManager->getApplication().addGameState(new ScreenCommandes(m_RManager));
    }

    return true;
}

PauseMenu::~PauseMenu()
{
    m_RManager->killTexture("data\\graphics\\window\\pausemenu\\background.png");
    m_RManager->killTexture("data\\graphics\\window\\pausemenu\\jeu.png");
    m_RManager->killTexture("data\\graphics\\window\\pausemenu\\menu.png");
    m_RManager->killTexture(m_commandes.getTexture());
    m_RManager->resumeBGM();
    m_RManager->deleteMouseCursor();
}
