#ifndef PLAYER_HPP
#define PLAYER_HPP

// C++
#include <fstream>
// SFML
#include <SFML/Window/Event.hpp>
// Projet
#include "ressourcemanager.hpp"
#include "sprite.hpp"
#include "entity.hpp"

class Player
{
public:
    Player(RessourceManager*);
    ~Player();
    void draw();
    void update(float);
    void event(const sf::Event&);
    void init();
    sf::FloatRect getHitbox();
    void setPosition(int, int);
    void move(float, float);
    void setSol(Entity*);
    Entity* getSol();
    void takeDamage(int);
    void setAccelV(float);
    void setAccel(float);
    void setVie(int);
    void resetMovement();
    void peuxTirer(bool);
    void setShootDelay(float);
    void save(std::ofstream&);
    void toggleGravity();
    bool isGravityNormal();
    void canToggleGravity(bool);

private:
    void calculerAcceleration(float);
    // C++
    bool haut, bas, droite, gauche;
    float vitesse, accel, pas, accelMax, accelV;
    int m_vieMax, m_vie;
    bool m_peuxTirer, m_clicGaucheEnfonce;
    int m_degatArme;
    float m_intervalleTir, m_delaiJusqueProchainTir;
    bool m_peuxChangerGravite;
    // SFML
    sf::Sprite m_hud_Bulle, m_hud_barreVie, m_hud_vie;
    // Projet
    RessourceManager* m_RManager;
    AnimatedSprite* m_sprite;
    Entity* m_sol;
};

#endif // PLAYER_HPP
