#ifndef SCREEN_HPP
#define SCREEN_HPP

// C++
// SFML
#include <SFML/Graphics.hpp>
// Projet
#include "gamestate.hpp"
#include "sprite.hpp"

class MapInterlude : public GameState
{
public:
    MapInterlude(RessourceManager*, std::string);
    ~MapInterlude();
    virtual void draw();
    virtual bool event(const sf::Event &);
    virtual void update(float);

private:
    // C++
    std::string m_nextLevelName;
    float m_tempsBloque;
    bool m_peuxEtrePasse;
    // SFML
    // Projet
    Sprite* m_background;
};

class GameOver : public GameState
{
public:
    GameOver(RessourceManager*);
    ~GameOver();
    void draw();
    bool event(const sf::Event &);

private:
    // C++
    std::string m_levelName;
    // SFML
    sf::Sprite m_recommencer, m_retourMenu;
    // Projet
    Sprite* m_background;
};

class ScreenCommandes : public GameState
{
public:
    ScreenCommandes(RessourceManager*);
    ~ScreenCommandes();
    virtual bool event(const sf::Event&);
    virtual void draw();

private:
    void loadScreen();
    // C++
    int m_idScreen;
    // SFML
    sf::Sprite m_screen;
    // projet
};

#endif // SCREEN_HPP
