#ifndef SPRITE_HPP
#define SPRITE_HPP

// C++
// SFML
#include <SFML/Graphics/Sprite.hpp>
#include <SFML/Graphics/Texture.hpp>
// Projet

class Sprite : public sf::Sprite
{
public:
    Sprite(const sf::Texture&);
    virtual ~Sprite();
    virtual bool update(float);
    virtual void setEtatY(int);
    virtual void setEtatX(int);
};

class RepeatedSprite : public Sprite
{
public:
    RepeatedSprite(const sf::Texture&, float vBas, float vGauche);
    ~RepeatedSprite();
    bool update(float);

private:
    // C++
    double m_vBas, m_vGauche;
    // SFML
    // Projet
};

class AnimatedSprite : public Sprite
{
public:
    AnimatedSprite(const sf::Texture&, int nbEtatX, int nbEtatY, float tpsEntreImages, bool changeEtatYToutSeul = true);
    ~AnimatedSprite();
    bool update(float);
    void setEtatY(int);
    void setEtatX(int);
    int getEtatY();
    int getEtatX();

private:
    // C++
    int m_nbEtatX, m_nbEtatY, m_etatX, m_etatY;
    int m_largeurSprite, m_hauteurSprite;
    bool m_changeEtatYToutSeul;
    float m_tpsEntreImages, m_tpsDepuisImage;
    // SFML
    // Projet
};

#endif // SPRITE_HPP
