#include "structentity.hpp"
#include "dialogue.hpp"
#include "application.hpp"
#include "consoleminigame.hpp"

GroundEntity::GroundEntity(RessourceManager* rm, Sprite* sp, HitboxType hT, int x, int y) : Entity(rm, sp, hT, x, y, true)
{}

GroundEntity::~GroundEntity() {}

PicEntity::PicEntity(RessourceManager* rm, Sprite* sp, int x, int y) : Entity(rm, sp, SpriteFilled, x, y, true, true)
{}

PicEntity::~PicEntity() {}

void PicEntity::onCollision()
{
    // On fait apparaitre une image de game over appropri
}

void PicEntity::activate()
{
    m_deadly = !m_deadly;

    if(m_deadly)
        m_sprite->setEtatY(0);
    else
        m_sprite->setEtatY(1);
}

DoorEntity::DoorEntity(RessourceManager* rm, Sprite* sp, int x, int y) : Entity(rm, sp, SpriteFilled, x, y, true),
    m_isOpen(false)
{}

DoorEntity::~DoorEntity() {}

void DoorEntity::activate()
{
    if(m_isOpen)
        close();
    else
        open();
}

void DoorEntity::open()
{
    m_isOpen = true;
    m_visible = false;
    m_typeHitbox = None;
    refreshHitbox();
}

void DoorEntity::close()
{
    m_isOpen = false;
    m_visible = true;
    m_typeHitbox = SpriteFilled;
    refreshHitbox();
}

DecorationEntity::DecorationEntity(RessourceManager* rm, Sprite* sp, int x, int y) : Entity(rm, sp, SpriteFilled, x, y, false) {}

DecorationEntity::~DecorationEntity() {}
