#ifndef TRIGGER_HPP
#define TRIGGER_HPP

// C++
// SFML
// Projet
#include "entity.hpp"

class ShootableTrigger : public Entity
{
public:
    ShootableTrigger(RessourceManager*, Sprite*, Entity*, int x, int y, float delay = 0.f);
    virtual ~ShootableTrigger();
    virtual void onShoot();
    virtual void activate();
    virtual void update(float);

protected:
    // C++
    // SFML
    // Projet
    Entity* m_destination;
};

class ActivableTrigger : public Entity
{
public:
    ActivableTrigger(RessourceManager*, Sprite*, Entity*, int x, int y, float delay = 0.f);
    virtual ~ActivableTrigger();
    virtual void activate();
    virtual void update(float);

protected:
    // C++
    // SFML
    // Projet
    Entity* m_destination;
};

class TimerActivableTrigger : public ActivableTrigger
{
public:
    TimerActivableTrigger(RessourceManager*, Sprite*, Entity*, int x, int y, float delay = 0.f);
    virtual ~TimerActivableTrigger();
    virtual void update(float);
};

class TimerShootableTrigger : public ShootableTrigger
{
public:
    TimerShootableTrigger(RessourceManager*, Sprite*, Entity*, int x, int y, float delay = 0.f);
    virtual ~TimerShootableTrigger();
    virtual void update(float);
};


#endif // TRIGGER_HPP
